<template>
	<div>
		<SpinnerHolder class="loader" v-if="loadingSpinner" :background="false"></SpinnerHolder>
		<CommonHeader :setOrden="true" :title="$t('identify')" :showIcon="true"></CommonHeader>
		<div class="layout">
			<input name="nav" type="radio" class="nav home-radio" id="home" checked="checked" @click="resetForm" />
			<div class="page home-page">
				<div class="page-contents">
					<form class="form-crear">
						<div class="form-group">
							<label>{{$t('email')}}</label>
							<input :placeholder="$t('email')" v-model="email" />
						</div>

						<div class="form-group-password">
							<label>{{$t('password')}} </label>
							<div class="contenedor">
								<input :placeholder="$t('enterPassword')" :type="showPassword ? 'text' : 'password'" class="texto" v-model="password"/>
								<input
									class="imagen"
									type="image"
									src="https://pngimage.net/wp-content/uploads/2018/06/icono-ojo-png-5.png"
									width="20"
									height="15"
									@click.prevent="()=>showPassword = !showPassword"
								/>
							</div>
						</div>
						<div>
							<label>{{$t('confirmPass')}}</label>
							<div class="contenedor">
							<input :placeholder="$t('enterPassword')" :type="showConfirmPassword ? 'text' : 'password'" class="texto" v-model="confirmPassword"/>
							<input
								class="imagen"
								type="image"
								src="https://pngimage.net/wp-content/uploads/2018/06/icono-ojo-png-5.png"
								width="20"
								height="15"
								@click.prevent="()=>showConfirmPassword = !showConfirmPassword"
							/>
							</div>
						</div>
					</form>

					<AjaxButton
						class="final-button"
						:loading="loading"
						:text="$t('continue')"
						@click="sigUpWithEmail()"
					></AjaxButton>
					<span v-if="displayError" class="error">{{ error }}</span>
					<div class="options">
						<div>
							<BeeCheckbox class="check" v-model="selected"></BeeCheckbox>
							<p><a href=""> {{$t('termsConditions')}} </a></p>
						</div>
					</div>

					<LineDecoration></LineDecoration>

					<div class="login-social">
						<Google :title="$t('ConectarGoogle')"></Google>
						<!-- <Facebook :title="$t('ConectarFacebook')"></Facebook> -->
					</div>
				</div>
			</div>
			<label class="nav" for="home">
				<span> {{$t('createAccount')}} </span>
			</label>

			<input name="nav" type="radio" class="about-radio" id="about" @click="resetForm" />
			<div class="page about-page">
				<div class="page-contents">
					<form class="form-crear">
						<div class="form-group">
							<label>{{$t('email')}}</label>
							<input :placeholder="$t('email')" v-model="email" />
						</div>

						<div>
							<label>{{$t('password')}} </label>
							<div class="contenedor">
								<input
									:placeholder="$t('enterPassword')"
									:type="showPassword ? 'text' : 'password'"
									class="texto"
									v-model="password"
								/>
								<input
									class="imagen"
									type="image"
									src="https://pngimage.net/wp-content/uploads/2018/06/icono-ojo-png-5.png"
									width="20"
									height="15"
									@click.prevent="() => (showPassword = !showPassword)"
								/>
							</div>
						</div>
					</form>

					<AjaxButton
						class="final-button"
						:loading="loading"
						:text="$t('login')"
						@click="loginWithEmail()"
					></AjaxButton>

					<span v-if="displayError" class="error">{{ error }}</span>

					<div class="options">
						<a @click="newPassword()"><strong>{{$t('forgotPass')}}</strong></a>
					</div>

					<LineDecoration></LineDecoration>

					<div class="login-social">
						<Google :title="$t('ConectarGoogle')"></Google>
						<!-- <Facebook :title="$t('ConectarFacebook')"></Facebook> -->
					</div>
				</div>
			</div>
			<label class="nav" for="about">
				<span> {{$t('login')}} </span>
			</label>
		</div>
	</div>
</template>
<script lang="ts">
import { Component, Vue } from 'vue-property-decorator'
import CommonHeader from '@/components/CommonHeader.vue'
import AjaxButton from '@/components/AjaxButton.vue'
import BeeCheckbox from '@/components/BeeCheckbox.vue'
import Google from '@/components/ButtonGoogle.vue'
import Facebook from '@/components/ButtonFacebook.vue'
import LineDecoration from '@/components/LineDecoration.vue'
import auth from '@/config/auth'
import SpinnerHolder from '@/components/SpinnerHolder.vue'
import {getUser} from "@/services/UserService"
import Menu from '@/models/Menu'
import { redirect } from '@/utils/RedirectUtils'

@Component({
	components: {
		CommonHeader,
		AjaxButton,
		BeeCheckbox,
		Google,
		Facebook,
		LineDecoration,
		SpinnerHolder
	}
})
export default class Login extends Vue {
	loading = false;
	loadingSpinner = false;
	selected = false;
	email = '';
	password = '';
	confirmPassword = '';
	showPassword = false;
	showConfirmPassword = false;
	displayError = false;
	error = '';
	menu = this.$store.state.menu as Menu

	async sigUpWithEmail(){
		this.loading = true
		this.displayError = false;
		this.error='';

		if (this.password.length < 6){
			this.error = this.$t('weakPassword').toString();
			this.displayError = true;
			this.loading = false
			return ;
		}

		if (this.password !== this.confirmPassword){
			this.error = this.$t('wrongPasswordConfirm').toString();
			this.displayError = true;
			this.loading = false
			return ;
		}

		if (!this.selected){
			this.error = this.$t('wrongTerm').toString();
			this.displayError = true;
			this.loading = false
			return ;
		}

		try {
			await auth.createUserWithEmailAndPassword(this.email.trim(),this.password.trim());
			this.$analytics.logEvent('sign_up', {
				method: 'Email'
			})
			redirect()
		} catch (e){
			switch (e.code){
				case ('auth/invalid-email'):
					this.error = this.$t('invalidEmail').toString();
					this.loading = false
					break;
				case ('auth/email-already-in-use'):
					this.error = this.$t('emailInUse').toString();
					this.loginWithEmail()
					this.loading = false
					break;
				case ('auth/operation-not-allowed'):
					this.error = this.$t('defaultErrorSigIn').toString();
					this.loading = false
					break;
				case ('auth/weak-password'):
					this.error = this.$t('weakPassword').toString();
					this.loading = false
					break;
				default:
					this.error = this.$t('defaultErrorSigIn').toString();
					this.loading = false
					break;
			}
			this.$analytics.logEvent('sign_up_error', {
				method: 'Email',
				error: e.code
			})
			this.displayError = true;
		}
		this.loading = false
	}

	async loginWithEmail(){
		this.loadingSpinner = true
		this.displayError = false;
		this.error = '';
		try {
			const response = await auth.signInWithEmailAndPassword(this.email.trim(),this.password.trim());
			if(response.user) {
				this.$analytics.logEvent('login', {
					method: 'Email'
				});
				const user = await getUser(response.user);
				await this.$store.dispatch('login', user);
				redirect()
				this.loadingSpinner = false;
			}
		} catch (e){
			switch (e.code){
				case ('auth/invalid-email'):
					this.error = this.$t('invalidEmail').toString();
				break;
				case ('auth/user-disabled'):
					this.error = this.$t('userDisabled').toString();
				break;
				case ('auth/user-not-found'):
					this.error = this.$t('userNotFound').toString();
				break;
				case ('auth/wrong-password'):
					this.error = this.$t('wrongPassword').toString();
				break;
				default:
					this.error = this.$t('defaultErrorSigIn').toString();
					break;
			}
			this.$analytics.logEvent('login_error', {
				method: 'Email',
				error: e.code
			})
			this.loadingSpinner = false;
			this.displayError = true;
		}
	}

	resetForm(){
		this.error = '';
		this.displayError = false;
	}

	newPassword(){
		this.$router.push("/wrongPassword")
	}
}
</script>
<style lang="scss" scoped>
.loader {
	position: fixed;
	z-index: 2000;
	background-color: rgba(0, 0, 0, 0.8);
}

a {
	cursor: pointer;
}

.layout {
	display: grid;
	height: 100%;
	width: 100%;
	overflow: hidden;
	grid-template-rows: 50px 1fr;
	grid-template-columns: 1fr 1fr;
}

input[type='radio'] {
	display: none;
}

label.nav {
	display: flex;
	align-items: center;
	justify-content: center;
	cursor: pointer;

	color: rgba(0, 0, 0, 0.54);
	user-select: none;
	transition: background 0.4s, padding-left 0.2s;
	padding-left: 0;
	input[type='radio']:checked + .page + & {
		font-size: 16px;
		font-weight: 600;
		color: #f2c94c;
		border-bottom: 2px solid #f2c94c;
		padding-left: 20px;
		span {
			padding-left: 20px;
		}
	}
	span {
		padding-left: 0px;
		position: relative;
		text-transform: uppercase;
	}
}

.page {
	grid-column-start: 1;
	grid-row-start: 2;
	grid-column-end: span 3;
	padding: 0px 20px;
	display: flex;
}

.page-contents > * {
	opacity: 0;
	transform: translateY(20px);
	transition: opacity 0.2s, transform 0.2s;
	@for $c from 1 through 20 {
		&:nth-child(#{$c}) {
			transition-delay: 0.2s + ($c * 0.2s);
		}
	}
}

input[type='radio'] + .page {
	transition: transform 0.2s;
	transform: translateX(100%);
}

input[type='radio']:checked + .page {
	transform: translateX(0%);
	.page-contents > * {
		opacity: 1;
		transform: translateY(0px);
	}
}

.page-contents {
	max-width: 100%;
	width: 100%;
	margin: 0.5em auto;
}

.form-crear {
	label {
		font-size: 1em;
		color: #000;
		margin-bottom: 0.4em;
	}
	.form-group {
		display: grid;
		margin: 1em 0;

		input {
			border-radius: 7px;
			border: 0.5px solid rgba(192, 192, 192, 1);
			padding: 0.8em 0.8em 0.8em 10px;
		}
		input::-webkit-input-placeholder {
			color: rgba(117, 112, 112, 1);
			font-size: 1.2em;
		}
	}
}

div.contenedor {
	border: 1px solid #d7d7d7;
	margin: 0.4em 0 0;
	padding: 0;
	border-radius: 7px;
}
input.texto {
	border: 0px;
	width: 85%;
	position: relative;
	background: transparent;
	outline: none;
	padding: 0.8em 0.8em 0.8em 10px;
}
input.imagen {
	width: 20px;
	border: 0px;
	position: relative;
	top: 1px;
}
input.texto::-webkit-input-placeholder {
	color: rgba(117, 112, 112, 1);
	font-size: 1.2em;
}

.final-button {
	margin: 1.2em 0px;
}

.login-social button {
	margin-top: 1em;
}

.options {
	text-align: center;
	div {
		.check {
			display: inline-block;
			width: 13px;
			height: 13px;
		}
		p,
		p > a {
			display: inline-block;
			font-size: 1em;
			color: #757070;
		}
		p {
			margin-left: 0.5em;
		}
	}
	a {
		text-decoration: none;
		color: #000;
	}
}

.error {
	font-size: 12px;
	color: red;
	margin: auto;
}

.form-group-password {
	margin: 1em 0;
}

.final-button {
	color: #ffffff;
	font-size: 18px;
	line-height: 27px;
	font-weight: 500;
}
</style>
